# -#-   Python    -#- 
#
# Authors: Nik Kim <fafhrd@datacom.kz> 
# File: LocalizedVars.py
# Created: Fri Apr 12 15:14:52 2002
#

import Globals, traceback
from Acquisition import aq_base

class LocalizedVars:

    __localized_vars__ = {}

    def __getattr__(self, name):
        if self.__localized_vars__.has_key(name):
            lo_name = '__lo_%s' % name
            try:
                lang = Globals.get_request().context_lang
                return self.__dict__[lo_name][lang]
            except KeyError:
                return self.__localized_vars__[name]
        else:
            try:
                return self.__dict__[name]
            except KeyError:
                raise AttributeError, name

    def __setattr__(self, name, value):
        if self.__localized_vars__.has_key(name):
            lo_name = '__lo_%s' % name
            try:
                lang = Globals.get_request().context_lang
                self.__dict__.setdefault(lo_name, {})[lang] = value
            except:
                pass
        else:
            self.__dict__[name] = value
            
        self.__changed__(1)


def regLocalizedVar(klass, vars):
    """ add list of var names """
    lo = getattr(klass, '__localzed_vars__', None)
    if lo is None:
        klass.__localized_vars__ = list(vars)
    else:
        klass.__localized_vars__.extend(vars)
