##############################################################################
# Copyright (C) 2001 Kim Nikolay <fafhrd@datacom.kz>

# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

##############################################################################
""" CMFLocalizer """
__version__='$Revision: 0.1 $'[11:-2]

import LocalizerTool, FSMessageCatalog, PortalLocaleContent, GettextExpr
from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory


utils.registerIcon(FSMessageCatalog.FSMessageCatalog,
                   'images/fsmessage_catalog.gif', globals())

contentClasses = ( PortalLocaleContent.PortalLocaleContent,
                   )

contentConstructors = ( PortalLocaleContent.manage_addLocaleContent,
                        )

factory_type_information = ( PortalLocaleContent.factory_type_information )
                            

tools = ( LocalizerTool.LocalizerTool,
          )
    
import sys
this_module = sys.modules[__name__]
localizer_globals = globals()

z_bases = utils.initializeBasesPhase1( contentClasses, this_module )
z_tool_bases = utils.initializeBasesPhase1( tools, this_module )

registerDirectory('skins', globals())
    

def initialize( context ):

    utils.initializeBasesPhase2( z_bases, context )
    utils.initializeBasesPhase2( z_tool_bases, context )
    utils.ToolInit('CMFLocalizer Tool', tools=tools,
                   product_name='CMFLocalizer',
                   icon='tool.gif',).initialize( context )
        
    utils.ContentInit( 'CMFLocalizer Content',content_types=contentClasses,
                       permission = 'Add portal content',
                       extra_constructors=contentConstructors,
                       fti=factory_type_information
                       ).initialize( context )

    GettextExpr.initialize()